
// clear all lines associated with this box
_.lines.clear()

// a better background color
_.window.background = vec(0.5, 0.5, 0.5)

// again, the 'input' to this process is a shape
var controlShape = new FLine().rect(10,10,500,500)

// which we can edit with the mouse
controlShape.tweaky = true

// translucent white
controlShape.color = vec(1,1,1,0.25)
controlShape.thicken = 1
_.lines.controlShape = controlShape

// make it editable
_.applyTweaks()

// at this point controlShape might no longer be a rectangle, after some edits

// build a list of 'spans' (diagonals between control points)
var spans = []
for(var i=0;i<controlShape.nodes.size()-3;i++)
{
	var a = controlShape.nodes[i].to
	var b = controlShape.nodes[i+2].to
	var span = new FLine().moveTo(a).lineTo(b)
	span.color = vec(0,0,0,1)
	spans.push(span)
	
	// draw the spans as well	
	_.lines.add(span)
}

// defines a function that build's a tour of the spans
tour = (along) => {
	
	var f = new FLine()
	
	// we do the spans once
	for(var i=0;i<spans.length;i++) {
		var at = spans[i].sampleAt(along)		
		f.lineTo(at)	
		
		// we wobble where we are sampling the span a little
		along += (Math.random()-0.5)*0.05
	}
	
	// and then do the 'other side'
	for(var i=0;i<spans.length;i++) {
		var at = spans[i].sampleAt(1-along)		
		f.lineTo(at)

		// we wobble where we are sampling the span a little
		along += (Math.random()-0.5)*0.05
	}
	
	// connect with the start of the line again
	f.lineTo(f.nodes[0].to)
	f.color = vec(0,0,0,0.5)

	// and draw it
	_.lines.add(f)
}

// draw 100 tours starting at 0 and ending at 0.5
for(var x of Anim.lineRange(0, 0.5, 100))
	tour(x)

// PROMPTS

// 1. try a different input shape

// 2. every 'Math.random()' marks a random distribution that might be worth manipulating

// 3. decorate the tours further: build a reason to 'curveTo' rather than 'lineTo'

// 4. turn this into an animation with _.wait() and _.redraw()
